#!/usr/local/bin/php -q
<?php
/**
 * form_template.cli.php
 * Code by Strangecode :: www.strangecode.com :: This document contains copyrighted information
 */

include_once dirname(__FILE__) . '/_config.inc.php';

// Test arguments.
if (isset($_SERVER['argv'][2])) {
    // Second arg is db table.
    $db_tbl = $_SERVER['argv'][2];
} else {
    die(sprintf("Usage: %s site_directory db_table\n", basename($_SERVER['argv'][0])));
}

// Get DB tables.
$qid = DB::query("SHOW TABLES");
while (list($row) = mysql_fetch_row($qid)) {
    $tables[] = $row;
}

// Make sure requested table is in database.
if (!in_array($db_tbl, $tables)) {
    die(sprintf("%s Warning: %s does not exist in database %s. Please select one of: \n\n%s\n\n", basename($_SERVER['argv'][0]), $db_tbl, App::getParam('db_name'), join("\n", $tables)));
}

// Get DB table column info.
$qid = DB::query("DESCRIBE " . addslashes($db_tbl));
while ($row = mysql_fetch_row($qid)) {
    $cols[] = $row;
}

$exclude = array('added_by_admin_id', 'added_datetime', 'hit_count', 'modified_datetime', 'modified_by_admin_id');
$primary_key_field = '';
$output = array();

// Loop through columns
if (is_array($cols) && !empty($cols)) {
    foreach ($cols as $col) {
        
        // Human readable.
        $field = $col[0];
        $title = ucfirst(str_replace('_', ' ', $field));
        $type = preg_replace('/^(\w+).*$/', '\\1', $col[1]);
        if ('PRI' == $col[3]) {
            $primary_key_field = $field;
        }
        
        // Column types like this are usually single toggle checkboxes.
        if (preg_match("/enum\('true'\)/", $col[1])) {
            $type = 'toggle';
        }
        
        if (in_array($field, $exclude) || $primary_key_field == $field) {
            // Don't add a field for this column.
            continue;
        }
        
        // Select menu from the column of a related database table.
        if (preg_match('/.*_id$/i', $field)) {
            $output[$field] = <<<E_O_F
    <tr>
        <td class="right"><label for="$field"<\x3fphp \$fv->err('$field', ' class="error"') \x3f>><\x3fphp echo _("$title"); \x3f></label></td>
        <td valign="top">
            <select name="$field" class="formselect">
            <\x3fphp printSelectForm('<##>_tbl', "CONCAT(<##>_id, '&mdash;', <##>)", '$field', \$frm['$field'], true, 'ORDER BY $field DESC'); \x3f>
            </select>
        </td>
    </tr>
E_O_F;
            continue;
        }
        
        // File upload.
        if (preg_match('/file/i', $field)) {
            $output[$field] = <<<E_O_F
    <tr>
        <td class="right"><label for="$field"<\x3fphp \$fv->err('$field', ' class="error"') \x3f>><\x3fphp echo _("$title"); \x3f></label></td>
        <td valign="top">
            <input type="file" name="$field" value="<\x3fphp echo \$_FILES['$field']['name']; \x3f>" />
            <\x3fphp if (getFormData('op') == 'edit' || getFormData('op') == 'update') { \x3f>
            <div class="help"><\x3fphp printf(_("The current file <strong>%s</strong> will be overwritten if a new file is selected for upload."), \$frm['$field']) \x3f></div>
            <\x3fphp } \x3f>
            <div class="help"><\x3fphp printf(_("File to upload must have one of the following file-name extensions: %s."), join(', ', \$upload->valid_file_extensions)) \x3f></div>
        </td>
    </tr>
E_O_F;
            continue;
        }
        
        // Password field.
        if (preg_match('/pass/i', $field)) {
            $output[$field] = <<<E_O_F
    <tr>
        <td class="right"><label for="$field"<\x3fphp \$fv->err('$field', ' class="error"') \x3f>><\x3fphp echo _("$title"); \x3f></label></td>
        <td valign="top">
            <input type="password" class="forminputtext" size="50" name="$field" value="<\x3fphp echo oTxt(\$frm['$field']); \x3f>">
        </td>
    </tr>
E_O_F;
            continue;
        }
        
        switch ($type) {
        
        // Select menu (or radio buttons)
        case 'enum' :
            $output[$field] = <<<E_O_F
    <tr>
        <td class="right"><label for="$field"<\x3fphp \$fv->err('$field', ' class="error"') \x3f>><\x3fphp echo _("$title"); \x3f></label></td>
        <td valign="top">
            <select name="$field">
            <\x3fphp printSetSelectForm('$db_tbl', '$field', \$frm['$field'], true); \x3f>
            </select>
        </td>
    </tr>
E_O_F;
            break;
        
        // Set checkboxes
        case 'set' :
            $output[$field] = <<<E_O_F
    <tr>
        <td class="right"><label for="$field"<\x3fphp \$fv->err('$field', ' class="error"') \x3f>><\x3fphp echo _("$title"); \x3f></label></td>
        <td valign="top">
            <\x3fphp printSetCheckboxes('$db_tbl', '$field', \$frm['$field'], 1) \x3f>
        </td>
    </tr>
E_O_F;
            break;
        
        // Single checkbox
        case 'toggle' :
            $output[$field] = <<<E_O_F
    <tr>
        <td>&nbsp;</td>
        <td>
            <input type="checkbox" name="$field" <\x3fphp frmChecked(!empty(\$frm['$field'])) \x3f>><label><\x3fphp echo _("$title"); \x3f></label>
        </td>
    </tr>
E_O_F;
            break;
            
        // Textarea
        case 'tinytext' :
        case 'text' :
        case 'mediumtext' :
        case 'longtext' :
        case 'tinyblob' :
        case 'blob' :
        case 'mediumblob' :
        case 'longblob' :
            $output[$field] = <<<E_O_F
    <tr>
        <td class="right"><label for="$field"<\x3fphp \$fv->err('$field', ' class="error"') \x3f>><\x3fphp echo _("$title"); \x3f></label></td>
        <td valign="top">
            <textarea class="text" cols="75" rows="4" name="$field"><\x3fphp echo oTxt(\$frm['$field']); \x3f></textarea>
        </td>
    </tr>
E_O_F;
            break;
        
            
        // Text
        case 'tinyint' :
        case 'bit' :
        case 'bool' :
        case 'smallint' :
        case 'mediumint' :
        case 'int' :
        case 'integer' :
        case 'bigint' :
        
        case 'float' :
        case 'float' :
        case 'double' :
        case 'double' :
        case 'real' :
        case 'decimal' :
        case 'dec' :
        case 'numeric' :
        
        case 'date' :
        case 'datetime' :
        case 'timestamp' :
        case 'time' :
        case 'year' :
        
        case 'char' :
        case 'varchar' :
        default :
            $output[$field] = <<<E_O_F
    <tr>
        <td class="right"><label for="$field"<\x3fphp \$fv->err('$field', ' class="error"') \x3f>><\x3fphp echo _("$title"); \x3f></label></td>
        <td valign="top">
            <input type="text" class="text" size="50" name="$field" value="<\x3fphp echo oTxt(\$frm['$field']); \x3f>">
        </td>
    </tr>
E_O_F;
            break;
        }
    }
} else {
    die(basename($_SERVER['argv'][0]) . " Warning: $db_tbl does not have any columns.\n");
}


echo join("\n", $output);

?>